* Contabil Profesional 4.48.0 13.06.02 11:07:08
*
* Aplicatie:UF
* Titlu:    Fise facturi pe agent, ordonate dupa denumirea partenerilor                                                                                                                                                       
* Raport:   UF_AG_1   
* Descriere:Pentru fiecare agent, facturile pentru parteneri in ordinea datei scadentei                                                                                                                     

* Bazat pe: Fise facturi , achitate partial sau integral ,ordonate si grupate dupa data scadentei, agent, partener;2
* Bazat pe: Fise facturi ,ordonate si grupate dupa data scadentei, agent, partener;1                                                                              
* Bazat pe: Centralizator facturi , ,ordonate si grupate dupa data scadentei, agent, partener                                                                     
* Bazat pe: Centralizator facturi , pe agent ,ordonate si grupate dupa data scadentei                                                                             
* Bazat pe: Centralizator facturi , pe agent , localitate,denumire partener                                                                                       
* Bazat pe: Centralizator facturi , grupate pe parteneri ordonati dupa localitate denumire                                                                        
* Bazat pe: Centralizator facturi , grupate pe parteneri ordonati dupa localitate si abreviere                                                                    
* Bazat pe: Centralizator facturi , grupate pe parteneri ordonati dupa abreviere                                                                                  
* Bazat pe: Centralizator facturi , grupate pe parteneri , ordonati dupa denumire                                                                                                         

*
*
*
* ..\Teste\TSql10

*-*Close Data
*-*scrLocalitatea = ""
*-*scrPartener = "HERI"
*-*scrAgent = ""
*-*__CaleDBF = "P:\CTBW-J\FIRME\GABI300\DBFS\"
*-*tipAplUf = 'o'
*-*

* Un tabel care sa contina pentru pe primul rand factura si prima chitanta
* pe al doilea factura si a doua chitanta , samd
* Pentru cele care nu s-au achitat de loc contine factura si -1 ca nr int de doc ch


Private	xLocalitatea, xPartener, xAgent 		&&

xLocalitatea = Lower("*"+AllTrim(scrLocalitatea)+"*")
xPartener    = Lower("*"+AllTrim(scrPartener)+"*")
xAgent		 = Lower("*"+AllTrim(scrAgent)+"*")


*scrDataScI = {}
*scrDataScF = Date()
*scrDataFaI = {}
*scrDataFaF = Date()

*
* Mai intai selectez de prin facturi, parteneri , agenti, cele care s-ar incadra
* in criteriile impuse
* Nu ma intereseaza decat campul UFF_NRI_FA

Select 													;
	  uff.UFF_NRI_FA									;
	 ,uff.UFF_NRI_PA									;
 	 ,uff.UFF_TS_F, uff.UFF_TS_A, uff.UFF_SOLD			;
 	 From 												;
        __CaleDBF+"Uff_"+tipAplUf uff					;
	   ,__CaleDBF+"Partener" p							;
       ,__CaleDBF+"Agenti"   a							;
	Into Table tmp0										;
	Where 												;
			uff.UFF_NRI_PA = p.PA_NR_I 					;
		And	p.PA_AGENT = a.AG_NR_I						;
														;
		And Like(xAgent,		Lower(AG_NUME))			;
		And Like(xLocalitatea,	Lower(PA_LOCALIT))		;
		And (Like(xPartener,    Lower(PA_DENUMIR))		;
		      Or										;
			 Like(xPartener,    Lower(PA_ABREV))		;
		     )											;
		And Between(uff.UFF_DATA_S, scrDataScI, scrDataScF)	;
		And Between(uff.UFF_DATA_F, scrDataFaI, scrDataFaF)



*** Tratez bifele de achitare
Do Case
	Case __UfKAch And __UfKNeach
		Select * From tmp0 Into Table tmp1 Where .T.
	Case __UfKAch And !__UfKNeach
		Select * From tmp0 Into Table tmp1 Where UFF_SOLD = 0
	Case !__UfKAch And __UfKNeach
		Select * From tmp0 Into Table tmp1 Where UFF_SOLD != 0
	Case !__UfKAch And !__UfKNeach
		Select * From tmp0 Into Table tmp1 Where .F.

EndCase	
=ClsDbf("tmp0")


*
* In TMP1 am facturile, selectate doar cele cu var din ecran
*

*
* Acuma sa iau toate tz  care nu sunt stornate pt aceste facturi 
* Voi avea facturi din tz
* 
Select 											;
	 t.TZ_NRI_DF								;
	,fsel.UFF_NRI_PA							;
 	,fsel.UFF_TS_F, fsel.UFF_TS_A, fsel.UFF_SOLD;
	,t.TZ_NRI_DS								;
	,t.TZ_SUMA As SUMA_F						;
	,0000000000000.00 As SUMA_A					;
												;
	From 										;
		tmp1	fSel							;
		,(__CaleDBF+"UfTz_"+tipAplUf) t			;
	Into Table tmpFac							;
	Where 										;
			t.TZ_NRI_DF = fsel.UFF_NRI_FA		;
		And t.TZ_STORNAT = .F.					;
		And t.TZ_TIP = 1						;

*
* Iau doar chitante din tz 
* Cu ocazia asta grupez, sa nu apara si stornarile
*
Select 											;
	 t.TZ_NRI_DF								;
	,t.TZ_NRI_DS								;
	,0000000000000.00 As SUMA_F					;
	,Sum(t.TZ_SUMA) As SUMA_A					;
												;
	From 										;
		tmp1	fSel							;
		,(__CaleDBF+"UfTz_"+tipAplUf) t			;
	Into Table tmpChit							;
	Where 										;
			t.TZ_NRI_DF = fsel.UFF_NRI_FA		;
		And t.TZ_STORNAT = .F.					;
		And t.TZ_TIP = 2						;
	Group By TZ_NRI_DF , TZ_NRI_DS				

*
* 1. Iau facturi care au chitante
* 2  union din facturie car nu sunt in chitante
*
Select 											;
	 f.TZ_NRI_DF								;
	,f.UFF_NRI_PA								;
 	,f.UFF_TS_F, f.UFF_TS_A, f.UFF_SOLD			;
	,c.TZ_NRI_DS								;
	,f.SUMA_F									;
	,c.SUMA_A									;
	From tmpfac f								;
		,tmpChit c 								;
	Into Table tmpOk							;
	Where f.TZ_NRI_DF = c.TZ_NRI_DF				;
Union Select 									;
	 f.TZ_NRI_DF								;
	,f.UFF_NRI_PA								;
 	,f.UFF_TS_F, f.UFF_TS_A, f.UFF_SOLD			;
	,-000000000001 As TZ_NRI_DS					;
	,f.SUMA_F									;
	,0000000000000.00 As SUMA_A					;
	From tmpfac f								;
	Where Not Exists (Select * From tmpChit c Where f.TZ_NRI_DF = c.TZ_NRI_DF	)	

	
	
*
* Am ce mi-am dorit asa de mult: 
* Un tabel care sa contina pentru pe primul rand factura si prima chitanta
* pe al doilea factura si a doua chitanta , samd
* Pentru cele care nu s-au achitat de loc contine factura si -1 ca nr int de doc ch


*
*
* Acuma impanez cu nr, tip, data doc pt factura si chitanta
* Documentul factura exista 
*         - asa cum este luat din UFF in coloanele FAC_DOC_
*         - asa cum corespunde el in DOC_NRI
*    Astea Ar trebui sa coincida, dar datorita receptiilor nu !
*           


Select									;
 	 a.AG_NR_I							;
 	,p.PA_NR_I							;
 	,t.TZ_NRI_DF						;
	,t.TZ_NRI_DS						;
	,df.DNI_DOC_TI						;
	,df.DNI_DOC_NR						;
	,df.DNI_DOC_DA						;
 	,uff.UFF_NRI_FA						;
 	,uff.UFF_TIP_DO	As FAC_DOC_TI		;
	,uff.UFF_NR_FAC	As FAC_DOC_NR		;
	,uff.UFF_DATA_F	As FAC_DOC_DA		;
	,uff.UFF_DATA_S						;
 	,t.UFF_TS_F, t.UFF_TS_A, t.UFF_SOLD	;
	,t.SUMA_F							;
	,da.DNI_DOC_TI	As ACH_DOC_TI		;
	,da.DNI_DOC_NR  As ACH_DOC_NR		;
	,da.DNI_DOC_DA	As ACH_DOC_DA		;
	,t.SUMA_A							;
    ,a.AG_NUME,Trim(a.AG_ADRESA)+' '+Trim(a.AG_TELEFON) As SQ_AG_ADR;
	,p.PA_ABREV, p.PA_DENUMIR, p.PA_LOCALIT	;
	,Trim(p.PA_CONTACT)+' '+Trim(p.PA_TEL)+" "+Trim(p.PA_CONTAC1)+" "+Trim(p.PA_TEL1) As SQ_CONTACT	;
										;
	 From 								;
	 	tmpOk t							;
        ,__CaleDBF+"Uff_"+tipAplUf uff	;
	 	,__CaleDBF+"DOC_NRI" df			;
	 	,__CaleDBF+"DOC_NRI" da			;
	    ,__CaleDBF+"Partener" p			;
        ,__CaleDBF+"Agenti" a			;
	Into Table tmp						;
	Where 								;
			t.TZ_NRI_DF = df.DNI_NR_I	;
		And t.TZ_NRI_DF = uff.UFF_NRI_FA;
		And	t.TZ_NRI_DS = da.DNI_NR_I	;
		And t.UFF_NRI_PA = p.PA_NR_I	;
		And p.PA_AGENT = a.AG_NR_I		;
	Order By  AG_NUME					;
  			, PA_DENUMIR				;
  			, UFF_DATA_S				;
			, FAC_DOC_DA, FAC_DOC_NR	;
			, ACH_DOC_DA, ACH_DOC_NR

*
* In fiecare rand este f.SUMA_F - ar trebui sa fie doar in primul rand !
* Pun direct dar Atentie! nu se stie pe care articol a pus suma facturata
*

Private oTZ_NRI_DF
oTZ_NRI_DF = -79

Scan All
	If oTZ_NRI_DF = TZ_NRI_DF Then
		* Ca si cel dinainte. Pun 0 la valoare facturata
		Replace SUMA_F With 0
	EndIf
	oTZ_NRI_DF = TZ_NRI_DF  && retin 

EndScan


*
* Daca vrea browse, il facem
*
If _sqVreaBrowse Then
		
	Browse 												;
		Normal											;
		NoMenu											;
		NoEdit											;
		NoAppend										;
		NoDelete										;
		Preference (_sqPrefBrowse) 						;
		Title (_sqTxtTitlu)								;
		Fields											;
			 AG_NUME        :H="Agent"					;
			,PA_ABREV	 	:H="Client"					;
			,PA_DENUMIR 	:H="Denumire client"		;
			,FAC_DOC_TIP	:H="Doc"					;
			,FAC_DOC_NR		:H="Nr.doc"					;
			,FAC_DOC_DA		:H="Data doc"				;
			,UFF_DATA_S		:H="Scadenta"				;
			,UFF_TS_F  		:H="Valoare fact"			;
							:P="9,999,999,999,999.99"	;
			,UFF_TS_A  		:H="Valoare achit"			;
							:P="9,999,999,999,999.99"	;
			,UFF_SOLD  		:H="Sold"					;
							:P="9,999,999,999,999.99"	;
			,ACH_DOC_TIP	:H="Ach"					;
			,ACH_DOC_NR		:H="Nr.doc.ach"				;
			,ACH_DOC_DA		:H="D.achit"				;
			,SUMA_A			:H="Suma achitata"			;
							:P="9,999,999,999,999.99"	;
			,DNI_DOC_TIP	:H="Doc"					;
			,DNI_DOC_NR		:H="Nr.doc"					;
			,DNI_DOC_DA		:H="Data doc"				;
			,PA_LOCALIT 	:H="Localitate"				;
			,SQ_CONTACT		:H="Contact partener"		;
			,SQ_AG_ADR		:H="Adresa agent"

EndIf	&& _sqVreaBrowse
