* Contabil Profesional 4.48 03.01.02 21:50:51
*
* Aplicatie:UF
* Titlu:    Centralizator facturi , ,ordonate si grupate dupa data scadentei, agent, partener                                                                     
* Raport:   UF_SCAD      
* Descriere:Pentru fiecare data calendaristica in care sunt facturi scadente se afiseaza facturile , grupat pe agent, localitate, partener                                                                                                   

* Bazat pe: Centralizator facturi , pe agent ,ordonate si grupate dupa data scadentei                                                                             
* Bazat pe: Centralizator facturi , pe agent , localitate,denumire partener                                                                                       
* Bazat pe: Centralizator facturi , grupate pe parteneri ordonati dupa localitate denumire                                                                        
* Bazat pe: Centralizator facturi , grupate pe parteneri ordonati dupa localitate si abreviere                                                                    
* Bazat pe: Centralizator facturi , grupate pe parteneri ordonati dupa abreviere                                                                                  
* Bazat pe: Centralizator facturi , grupate pe parteneri , ordonati dupa denumire                                                                                                         


Private	xLocalitatea, xPartener, xAgent 		&&

xLocalitatea = Lower("*"+AllTrim(scrLocalitatea)+"*")
xPartener    = Lower("*"+AllTrim(scrPartener)+"*")
xAgent		 = Lower("*"+AllTrim(scrAgent)+"*")




Select 													;
     a.AG_NUME, a.AG_NR_I, Trim(a.AG_ADRESA)+' '+Trim(a.AG_TELEFON) As SQ_AG_ADR;
	,p.PA_NR_I	 										;
	,p.PA_ABREV, p.PA_DENUMIR, p.PA_LOCALIT				;
	,Trim(p.PA_CONTACT)+' '+Trim(p.PA_TEL)+" "+Trim(PA_CONTAC1)+" "+Trim(PA_TEL1) As SQ_CONTACT	;
	,d.DNI_DOC_TIP, d.DNI_DOC_NR, d.DNI_DOC_DA			;
	,d.DNI_DOC_DO, d.DNI_DATA_S, d.DNI_ORA_SI			;
	,uff.UFF_TIP_DO, uff.UFF_NR_FAC, uff.UFF_DATA_F		;
	,uff.UFF_DATA_S										;
	,uff.UFF_TS_F, uff.UFF_TS_A, uff.UFF_SOLD			;
	 From 												;
	   __CaleDBF+"Partener" p							;
       ,(__CaleDBF+"Uff_"+tipAplUf) uff					;
       ,__CaleDBF+"Doc_NrI" d							;
       ,__CaleDBF+"Agenti" a							;
	Into Table TMP0										;
	Where 												;
		uff.UFF_NRI_PA = p.PA_NR_I 						;
		And 											;
		uff.UFF_NRI_FA = d.DNI_NR_I						;
		And												;
		p.PA_AGENT = a.AG_NR_I							;
														;
		And Like(xAgent,		Lower(AG_NUME))			;
		And Like(xLocalitatea,	Lower(PA_LOCALIT))		;
		And (Like(xPartener,    Lower(PA_DENUMIR))		;
		      Or										;
			 Like(xPartener,    Lower(PA_ABREV))		;
		     )											;
		And Between(UFF_DATA_S, scrDataScI, scrDataScF)	;
		And Between(DNI_DOC_DA, scrDataFaI, scrDataFaF)	;
														;
	Order By  UFF_DATA_S, AG_NUME, PA_LOCALIT, PA_DENUMIR, DNI_DOC_DA	


*** Tratez bifele de achitare
Do Case
	Case __UfKAch And __UfKNeach
		Select * From tmp0 Into Table tmp Where .T.
	Case __UfKAch And !__UfKNeach
		Select * From tmp0 Into Table tmp Where UFF_SOLD = 0
	Case !__UfKAch And __UfKNeach
		Select * From tmp0 Into Table tmp Where UFF_SOLD != 0
	Case !__UfKAch And !__UfKNeach
		Select * From tmp0 Into Table tmp Where .F.

EndCase	
=ClsDbf("tmp0")



*
* Daca vrea browse, il facem
*
If _sqVreaBrowse Then
		
	Browse 												;
		Normal											;
		NoMenu											;
		NoEdit											;
		NoAppend										;
		NoDelete										;
		Preference (_sqPrefBrowse) 						;
		Title (_sqTxtTitlu)								;
		Fields											;
			 AG_NUME        :H="Agent"					;
			,PA_ABREV	 	:H="Client"					;
			,PA_DENUMIR 	:H="Denumire client"		;
			,DNI_DOC_TIP	:H="Doc"					;
			,DNI_DOC_NR		:H="Nr.doc"					;
			,DNI_DOC_DA		:H="Data doc"				;
			,UFF_TIP_DO		:H="Fact"					;
			,UFF_NR_FAC		:H="Nr.fact"				;
			,UFF_DATA_F		:H="Data f."				;
			,UFF_DATA_S		:H="Scadenta"				;
			,UFF_TS_F  		:H="Valoare fact"			;
							:P="9,999,999,999,999.99"	;
			,UFF_TS_A  		:H="Valoare achit"			;
							:P="9,999,999,999,999.99"	;
			,UFF_SOLD  		:H="Sold"					;
							:P="9,999,999,999,999.99"	;
			,PA_LOCALIT 	:H="Localitate"				;
			,SQ_CONTACT		:H="Contact"				;
			,SQ_AG_ADR		:H="Adresa agent"

EndIf	&& _sqVreaBrowse
